-- Light3D --
pi, sqrt,acos = math.pi, math.sqrt, math.acos

function d3.light.load()
	light = {0,0,0}
	light.brightness = 0
	light.r = 255
	light.b = 255
	light.g = 255
	light.newColor = {}
	light.factor = 0
	light.ar, light.ag, light.ab = 0, 0, 0
end

function d3.light.setAmbience(r, g, b)
	light.ar = r
	light.ag = g
	light.ab = b
end

function d3.light.getLightFactor(pointA, pointB, pointC)
	ab = {
		pointA[1] - pointB[1],
		pointA[2] - pointB[2],
		pointA[3] - pointB[3]}
	bc = {
		pointB[1] - pointC[1],
		pointB[2] - pointC[2],
		pointB[3] - pointC[3]}
	norm = {
		-(ab[2] * bc[3] + (ab[3] * bc[2])),
		ab[1] * bc[3] + (ab[3] * bc[1]),
		-(ab[1] * bc[2]) + (ab[2] * bc[1])}

	dotProd = norm[1] * light[1] + norm[2] * light[2] + norm[3] * light[3]
	normMag = sqrt(norm[1] * norm[1] + norm[2] * norm[2] + norm[3] * norm[3])
	lightMag = sqrt(light[1] * light[1] + light[2] * light[2] + light[3] * light[3])
	return (acos(dotProd / (normMag * lightMag)) / pi) * light.brightness
end

function d3.light.getNewColor(pointA, pointB, pointC)
	light.factor = d3.light.getLightFactor(pointA, pointB, pointC)
	light.r = math.min(light.r * light.factor + light.ar,255)
	light.b = math.min(light.b * light.factor + light.ab,255)
	light.g = math.min(light.g * light.factor + light.ag,255)
	light.newColor = { light.r, light.g, light.b, 255 }
	return light.newColor
end
