-- Love3D Library Test 7 Modified--
d3 = require "Ref3D"
gr = love.graphics


	-- current offsets in present (only loaded once) -- only effect initial object center
	-- object rotation reversed for mouse ur & ll (ul & lr OK)

	-- changes made include:
		-- normals flipped so right-hand works
		-- light.newColor colors reordered from rbg to rgb
		-- activated color support for individual triangles
		-- added x & y screen offsets and zoom to triangle drawing
		-- changed triangle draw to p1,p2,p3,ox,oy,zoom from px1,py1,px2,py2,px3,py3
		-- eliminated set.light
		-- fixed light.getNewColor (b & g inverted)
		-- clamped color <255 to prevent color roll over
		-- added '=' to isBackFace
		-- eliminated x,y,z indexing & use of ipairs
		-- changed ambient setting to get truer colors
		-- added default to Cull
		-- added file input of geometry

function love.load()
	gr.setCaption("Very modified substitute541's Love3D")
	screenWidth			= 400
	screenHeight		= 300
	gr.setMode( screenWidth, screenHeight)
	vp					= { x = screenWidth/2, y = screenHeight/2 }	-- vanishing point
	fl					= 500				-- focal length
	d3.load(fl, vp.x, vp.y)
	d3.light.load()
	light.brightness	= .95				-- brightness (overrides that set in Light3D)
	offx, offy, zoom	= 0, 0, 0.1
	bkgnd				= gr.newImage('bg.jpg')
	selection 			= 1
	dz					= 0.1
	f					= 0		-- for multiple copies of same image (separation)
	--love._openConsole()
	name1 = 'teapot.r3d'
	name2 = 'x29.r3d'
	selectObject( selection )
	end

function love.keyreleased( key )
	if key == "e" then
		if zSortUsingMinZ then zSortUsingMinZ = false
			else zSortUsingMinZ	= true end
		end
	if key == 'r' then
		if isUsingBackCull then isUsingBackCull = false
			else isUsingBackCull = true end
		end
	end

function selectObject(sel)
	if sel == 1 then points, polygons = d3.loadData(name1) end
	if sel == 2 then points, polygons = d3.loadData(name2) end
	if sel == 3 then points, polygons = d3.preset.Sphere(80,0,0,0) end
	if sel == 4 then points, polygons = d3.preset.triPyramid(150,0,0,0) end
	if sel == 5 then points, polygons = d3.preset.triCube3D(80, 0, 0, 0) end
	if sel == 6 then points, polygons = d3.preset.Star(150,0,0,0) end
	if sel == 7 then points, polygons = d3.preset.square(100,0,0,0) end
	end

function love.update(dt)
	zoom = zoom + dz*dt dz=dz+0.01*dt
	if zoom>2.5 then zoom =.1 dz=.1 f=0 selection = selection<7 and selection +1 or 1 selectObject(selection) end
	local angX	= vp.x * 0.01 * dt
	local angY	= vp.y * 0.01 * dt
	light[1]	= love.mouse.getX() - vp.x
	light[2]	= love.mouse.getY() - vp.y
	for i = 1, #points do
		points[i][2],points[i][3] = d3.func.rotateX(points[i][2],points[i][3],angX,0,0)
		points[i][1],points[i][3] = d3.func.rotateY(points[i][1],points[i][3],angY,0,0)
		end
	if zSortUsingMinZ then							-- doesn't seem to make too much difference!
		d3.func.zSortTriangle2( polygons, points )
		else
		d3.func.zSortTriangle ( polygons, points )
		end
	if love.keyboard.isDown('d') then offx = offx > -216 and offx-.1 or -216 end
	if love.keyboard.isDown('a') then offx = offx <  220 and offx+.1 or  220 end
	if love.keyboard.isDown('s') then offy = offy > -127 and offy-.1 or -127 end
	if love.keyboard.isDown('w') then offy = offy <  127 and offy+.1 or  127 end
	f=f+25*dt
	end

function love.draw()
	gr.setColor( 255, 255, 255, 255 )
	gr.draw( bkgnd, -220 + offx, -130 + offy, 0, 0.7, 0.7 )
	for i = 1, #polygons do
		if polygons[i].color[1] then
			light.r = polygons[i].color[1]
			light.g = polygons[i].color[2]
			light.b = polygons[i].color[3]
			else
			light.r, light.g, light.b = 255, 0, 255
			end
		d3.light.setAmbience( 5, 5, 5 )
		local p1,p2,p3 = points[polygons[i][1]],points[polygons[i][2]],points[polygons[i][3]]
		love.graphics.setColor( d3.light.getNewColor(  p1, p2, p3 ) )
		d3.graphics.triangle( "fill", isUsingBackfaceCull, p1, p2, p3, offx,   offy,   zoom )
		--d3.graphics.triangle( "fill", isUsingBackfaceCull, p1, p2, p3, offx-f, offy,   zoom )
		--d3.graphics.triangle( "fill", isUsingBackfaceCull, p1, p2, p3, offx+f, offy,   zoom )
		--d3.graphics.triangle( "fill", isUsingBackfaceCull, p1, p2, p3, offx,   offy+f, zoom )
		--d3.graphics.triangle( "fill", isUsingBackfaceCull, p1, p2, p3, offx,   offy-f, zoom )
		end
	gr.setColor(255 * light.brightness, 255 * light.brightness, 255 * light.brightness, 255)
	d3.graphics.circle2D( "fill", light, 5, 20 )
	gr.setColor( 255, 255, 255, 255 )
	gr.print( 'fps: '..love.timer.getFPS( ), screenWidth - 95, screenHeight - 20 )
	d3.sight()
	end

function love.keypressed( key )
	if key == 'escape'		then love.event.push( 'quit' ) end
	if key == 'x' then love._openConsole() end
	end
